=== debian/changelog ===
faiss (1.10.0-2build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:14:00 +0000

faiss (1.10.0-2) unstable; urgency=medium

  * d/tests: add missing files for cmake-test
  * d/{rules,tests}: update names for flaky tests
  * Add patch to fix compilation of tests on 32-bit platforms

 -- Shengqi Chen <harry@debian.org>  Fri, 14 Feb 2025 21:33:50 +0800

faiss (1.10.0-1) unstable; urgency=medium

  * New upstream version 1.10.0
  * d/patches: refresh existing patches, remove applied
  * d/control: add myself in uploaders
  * Add a patch to disable installation of useless native example

 -- Shengqi Chen <harry@debian.org>  Thu, 13 Feb 2025 00:08:44 +0800
