=== debian/tests/control ===
Tests: python-test
Depends: python3-all, @
Restrictions: allow-stderr

Tests: cmake-test
Restrictions: allow-stderr
Depends: build-essential, cmake, g++ | c++-compiler, ninja-build, libgtest-dev, @
